#!/usr/bin/python3

import os
import time
import shutil

from watchdog.observers import Observer
from watchdog.events import FileSystemEventHandler

# Replace this with the folder path you want to monitor
folder_to_monitor = "/some/folder/to/monitor"  

class MyHandler(FileSystemEventHandler):
    def on_created(self, event):
        if event.is_directory:
            folder_path = event.src_path
            self.rename_mp3_files(folder_path)

    def rename_mp3_files(self, folder_path):
        folder_name = os.path.basename(folder_path)
        for filename in os.listdir(folder_path):
            if filename.lower().endswith(".mp3"):
                mp3_path = os.path.join(folder_path, filename)
                new_mp3_path = os.path.join(folder_path, folder_name + ".mp3")
                os.rename(mp3_path, new_mp3_path)
                print(f"Renamed {filename} to {folder_name}.mp3")

if __name__ == "__main__":
    event_handler = MyHandler()
    observer = Observer()
    observer.schedule(event_handler, folder_to_monitor, recursive=True)
    observer.start()

    try:
        while True:
            time.sleep(1)
    except KeyboardInterrupt:
        observer.stop()

    observer.join()
